CodeForces - 779D
Little Nastya has a hobby, she likes to remove some letters from word, to obtain another word. But it turns out to be pretty hard for her, because she is too young. Therefore, her brother Sergey always helps her.
Sergey gives Nastya the word t and wants to get the word p out of it. Nastya removes letters in a certain order (one after another, in this order strictly), which is specified by permutation of letters‘ indices of the word t
Sergey knows this permutation. His goal is to stop his sister at some point and continue removing by himself to get the word p. Since Nastya likes this activity, Sergey wants to stop her as late as possible. Your task is to determine, how many letters Nastya can remove before she will be stopped by Sergey.
It is guaranteed that the word p can be obtained by removing the letters from word t.
Input
The first and second lines of the input contain the words t and p, respectively. Words are composed of lowercase letters of the Latin alphabet (1?≤?|p|?<?|t|?≤?200?000). It is guaranteed that the word p can be obtained by removing the letters from word t.
Next line contains a permutation a1,?a2,?...,?a|t| of letter indices that specifies the order in which Nastya removes letters of t (1?≤?ai?≤?|t|, all ai are distinct).
Output
Print a single integer number, the maximum number of letters that Nastya can remove.
Examples
InputababcbaOutput
abb
5 3 4 1 7 6 2
3Input
bbbabbOutput
bb
1 6 3 4 2 5
4
Note
In the first sample test sequence of removing made by Nastya looks like this:
"ababcba" "ababcba" "ababcba" "ababcba"
Nastya can not continue, because it is impossible to get word "abb" from word "ababcba".
So, Nastya will remove only three letters.
題意:當初看這個題看了快一小時了還是不理解,我。。。。
就是給了兩個序列,序列a肯定包含序列b,然後給了一個刪除序列,刪除給定位置的字符,然後依照順序刪,看最多能刪幾個
思路:一開始肯定想的是直接遍歷,然後用個標記數組直接記錄哪個被刪了,然後就T了
範圍是 (1?≤?|p|?<?|t|?≤?200?000).然後我們想下,我們就是想求一個看能最多刪幾個的東西,去遍歷可以得到,但是一般遍歷能得到的東西,我們就可以想到二分,
如果刪這麽多滿足的話,就繼續往後二分,如果不行往前二分,時間復雜度就可以滿足了
#include <cstdio> #include <cstring> #include <algorithm> #include <cmath> #include <iostream> #include <vector> #include <queue> #include <string> #include <set> #include <map> using namespace std; const int maxn = 1e6+100; char a[maxn]; char b[maxn]; char tmp[maxn]; int c[maxn],n; bool slove(int pos) { strcpy(tmp,a); for(int i=0;i<pos;i++) tmp[c[i]-1] = 0; int res = 0; for(int i=0;i<n;i++) { if(tmp[i]==b[res]) res++; if(res==strlen(b)) return true; } if(res==strlen(b)) return true; else return false; } int main() { scanf("%s %s",a,b); n = strlen(a); for(int i=0;i<n;i++) scanf("%d",&c[i]); int l = 0,r = n; int k = 100; while(k--) { int mid = (l+r)/2; if(slove(mid)) l = mid; else r = mid; } printf("%d\n",l); return 0; }
要熟練掌握二分思想和滿足二分的情況
刷多點題提高敏感度
CodeForces - 779D